"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:libbasic3' }"

BuildDefinition subclass:#ProjectDefinition
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'System-Support-Projects'
!

!ProjectDefinition class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!ProjectDefinition class methodsFor:'defaults'!

defaultDescription
    ^ 'a classLibrary'
! !

!ProjectDefinition class methodsFor:'file generation'!

fileNamesToGenerate
    ^ #( 
          #('Make.proto' #'generate_make_dot_proto')
          #('Make.spec' #'generate_make_dot_spec')
          #('libInit.cc' #'generate_libInit_dot_cc')
          #('bc.def' #'generate_bc_dot_def')
          #('nt.mak' #'generate_nt_dot_mak')
          #('nt.def' #'generate_nt_dot_def')
          #('abbrev.stc' #'generate_abbrev_dot_stc') 
     )
! !

!ProjectDefinition class methodsFor:'file templates'!

bc_dot_def

^ 
'LIBRARY        %(LIBRARY_NAME)
DESCRIPTION     %(DESCRIPTION)
CODE            PRELOAD MOVEABLE DISCARDABLE
SEGMENTS
    INITCODE    PRELOAD DISCARDABLE
EXPORTS
    __%(C_LIBRARY_NAME)_Init     @1
'

    "Created: / 08-08-2006 / 12:26:58 / fm"
    "Modified: / 08-08-2006 / 19:32:27 / fm"
!

classLine_libInit_dot_cc

^'_%(CLASS)_Init(pass,__pRT__,snd);'

    "Created: / 08-08-2006 / 12:51:44 / fm"
    "Modified: / 08-08-2006 / 15:46:05 / fm"
!

extensionLine_libInit_dot_cc

^'_%(LIBRARY_NAME)_extensions_Init(pass,__pRT__,snd);'

    "Created: / 08-08-2006 / 15:48:56 / fm"
    "Modified: / 08-08-2006 / 19:32:33 / fm"
!

libInit_dot_cc

^ 
'/*
 * DO NOT EDIT 
 * automagically generated from Make.proto (by make libInit.cc)
 */
#define __INDIRECTVMINITCALLS__
#include <stc.h>
#define INIT_TEXT_SECT /* as nothing */
#ifdef WIN32
# pragma codeseg INITCODE "INITCODE"
#else /* not WIN32 */
# if defined(__GNUC__) && !!defined(NO_SECTION_ATTRIBUTES)
#  if (__GNUC__  == 2 && __GNUC_MINOR__ >= 7) || __GNUC__ > 2
#   undef INIT_TEXT_SECT
#   define INIT_TEXT_SECT __attribute__((section(".stxitext")))
#  endif
# endif /* not GNUC */
#endif /* not WIN32 */
#ifdef INIT_TEXT_SECT
extern void _%(LIBRARY_NAME)_Init() INIT_TEXT_SECT;
#endif
void _%(LIBRARY_NAME)_Init(pass, __pRT__, snd)
OBJ snd; struct __vmData__ *__pRT__; {
__BEGIN_PACKAGE2__("%(LIBRARY_NAME)", _%(LIBRARY_NAME)_Init, "%(PACKAGE)");
%(CLASSES)
%(EXTENSION)
__END_PACKAGE__();
}'

    "Created: / 08-08-2006 / 12:40:45 / fm"
    "Modified: / 08-08-2006 / 19:33:01 / fm"
!

make_dot_proto

^ 
'#
# Warning: once you modify this file, do not rerun
# stmkmp again - otherwise, your changes are lost.
#
# The Makefile as generated by this Make.proto supports the following targets:
#    make         - compile all st-files to a classLib
#    make install - install the classLib in /opt/smalltalk/...
#    make clean   - clean all temp files
#    make clobber - clean all

#
# position (of this package) in directory hierarchy:
# (must point to ST/X top directory, for tools and includes)
TOP=%(TOP)


# subdirectories where targets are to be made:
SUBDIRS=%(SUBDIRECTORIES)


# subdirectories where Makefiles are to be made:
# (only define if different from SUBDIRS)
# ALLSUBDIRS=


# if your embedded C code requires any system includes, 
# add the path(es) here:, 
# ********** OPTIONAL: MODIFY the next lines ***
# LOCALINCLUDES=-Ifoo -Ibar
LOCALINCLUDES=%(LOCAL_INCLUDES)


# if you need any additional defines for embedded C code, 
# add them here:, 
# ********** OPTIONAL: MODIFY the next lines ***
# LOCALDEFINES=-Dfoo -Dbar -DDEBUG
LOCALDEFINES=%(LOCAL_DEFINES)


#
# The next 2 defines should be left as-is
#  for a class-library package, you can uncomment the following:
#  (it does not hurt much, if you leave it as is - but you may NOT
#   uncomment it if object files are to be loaded individually later).
# INITCODESEPFLAG=$(SEPINITCODE)
#
#  the following MAY ONLY be uncommented for classes/classLibs,
#  which are ALWAYS statically included in the executable.
#  (i.e. NEVER for those which are subject to dynamic loading).
# COMMONSYMFLAG=$(COMMONSYMBOLS)
#
STCLOCALOPT=-I. $(LOCALINCLUDES) $(STCLOCALOPTIMIZATIONS) $(STCWARNINGS) $(LOCALDEFINES) -H. ''-P$(PACKAGE)'' ''-Z$(LIBNAME)'' $(COMMONSYMFLAG) $(INITCODESEPFLAG)


# ********** OPTIONAL: MODIFY the next line ***
# additional C-libraries that should be pre-linked with the class-objects
LD_OBJ_LIBS=


# ********** OPTIONAL: MODIFY the next line ***
# additional C targets or libraries should be added below
LOCAL_EXTRA_TARGETS=

all:: preMake classLibRule postMake


# add more install actions here
install::

# add more install actions for aux-files (resources) here
installAux::

# add more preMake actions here
preMake::

# add more postMake actions here
postMake:: cleanjunk

cleanjunk::

clean::
        -rm -f *.o *.H

clobber::
        -rm -f *.so *.dll

',
"
$(INSTALLBASE)::
        @test -d $@ || mkdir $@

$(INSTALLBASE)/packages:: $(INSTALLBASE)
        @test -d $@ || mkdir $@

$(INSTALLBASE)/packages/$(MODULE):: $(INSTALLBASE)/packages
        @test -d $@ || mkdir $@

$(INSTALLBASE)/packages/$(MODULE)/dapasx:: $(INSTALLBASE)/packages/$(MODULE)
        @test -d $@ || mkdir $@

$(INSTALLBASE)/packages/$(MODULE)/dapasx/interactiver_editor:: $(INSTALLBASE)/packages/$(MODULE)/dapasx
        @test -d $@ || mkdir $@

$(INSTALLBASE)/packages/$(MODULE)/$(MODULE_DIR):: $(INSTALLBASE)/packages/$(MODULE)
        @test -d $@ || mkdir $@
"
'
# if other things are to be compiled,
# add target definitions here,
# and list them in LOCAL_EXTRA_TARGETS above.
# (care for make syntax - TABS are required in the actions)
# foo:  foo.o
#         $(CC) -o foo foo.o

# ''make depend'' will add dependency info between
# BEGIN...END below
#
# BEGINMAKEDEPEND --- do not remove this line; make depend needs it
# ENDMAKEDEPEND --- do not remove this line

'

    "Created: / 08-08-2006 / 20:45:36 / fm"
    "Modified: / 09-08-2006 / 16:50:23 / fm"
!

make_dot_spec

^ 
'#
# This file contains specifications which are common to all platforms.
#
# Warning: once you modify this file, do not rerun
# stmkmp again - otherwise, your changes are lost.
#
# This file contains definitions for Unix based platforms.
#




# module and directory-in-module;
# these should correspond to the directory hierarchy
# location (otherwise, ST/X will have a hard time to
# find out the packages location from its packageID)
MODULE=%(MODULE)
MODULE_DIR=%(MODULE_DIRECTORY)


# the name of your classLibrary:
# ********** REQUIRED: CHECK the next line ***
LIBNAME=%(LIBRARY_NAME)


# the package is stored as an ID in classes and methods
# to identify code belonging to this project.
# It also specifies the position in the source repository
# and directory tree, when packages are loaded by packageID.
# ********** REQUIRED: CHECK the next line ***
PACKAGE=$(MODULE):$(MODULE_DIR)


# Argument(s) to the stc compiler.
#  -H.         : create header files locally
#                (if removed, they will be created as common
#  -Pxxx       : defines the package
#  -Zxxx       : a prefix for variables within the classLib
#  -Dxxx       : defines passed to to CC for inline C-code
#  -Ixxx       : include path passed to CC for inline C-code
#  +optspace   : optimized for space
#  +optspace2  : optimized more for space
#  +optspace3  : optimized even more for space
#  +optinline  : generate inline code for some ST constructs
#  +inlineNew  : additionally inline new
#  +inlineMath : additionally inline some floatPnt math stuff
#
# ********** OPTIONAL: MODIFY the next line(s) ***
# STCLOCALOPTIMIZATIONS=+optinline +inlineNew
# STCLOCALOPTIMIZATIONS=+optspace3
STCLOCALOPTIMIZATIONS=+optspace3


# Argument(s) to the stc compiler.
#  -warn            : no warnings
#  -warnNonStandard : no warnings about ST/X extensions
#  -warnEOLComments : no warnings about EOL comment extension
#  -warnPrivacy     : no warnings about privateClass extension
#
# ********** OPTIONAL: MODIFY the next line(s) ***
# STCWARNINGS=-warn
# STCWARNINGS=-warnNonStandard
# STCWARNINGS=-warnEOLComments
STCWARNINGS=

OBJS= \
%(OBJECTS)
'

    "Created: / 08-08-2006 / 19:31:29 / fm"
    "Modified: / 09-08-2006 / 15:10:57 / fm"
!

nt_dot_def

^
'LIBRARY        %(LIBRARY_NAME)
DESCRIPTION     %(DESCRIPTION)
VERSION         %(VERSION_NUMBER)
CODE            EXECUTE READ 
DATA            READ WRITE
SECTIONS
    INITCODE    READ EXECUTE 
    INITDATA    READ WRITE
EXPORTS 
    _%(LIBRARY_NAME)_Init      @1
IMPORTS'

    "Modified: / 08-08-2006 / 19:33:14 / fm"
!

nt_dot_mak

^
'#
# This file contains make rules for the win32 platform (using borland-bcc).
#
# Warning: once you modify this file, do not rerun
# stmkmp again - otherwise, your changes are lost.
#
TOP=%(TOP)

!!INCLUDE $(TOP)\rules\stdHeader_nt

!!INCLUDE Make.spec

LOCALINCLUDES=%(LOCAL_INCLUDES)

STCLOCALOPT=-I. $(LOCALINCLUDES) -H. $(STCLOCALOPTIMIZATIONS) $(STCWARNINGS) $(LOCALDEFINES) ''-P$(PACKAGE)'' ''-Z$(LIBNAME)'' $(COMMONSYMFLAG) $(INITCODESEPFLAG)

ALL::  $(LIBJPEG) $(LIBDIR)\$(LIBNAME).lib $(BINDIR)\$(LIBNAME).dll

!!INCLUDE $(TOP)\rules\stdRules_nt

# BEGINMAKEDEPEND --- do not remove this line; make depend needs it
# ENDMAKEDEPEND --- do not remove this line
'

    "Created: / 09-08-2006 / 11:44:20 / fm"
    "Modified: / 09-08-2006 / 19:59:32 / fm"
!

objectLine_make_dot_spec

^'    %(CLASS).$(O) \'

    "Created: / 08-08-2006 / 20:16:46 / fm"
! !

!ProjectDefinition class methodsFor:'mappings'!

bc_dot_def_mappings
    ^ (super bc_dot_def_mappings)
        at:#'LIBRARY_NAME' put:[ self libraryName ];
        at:#'C_LIBRARY_NAME' put:[ self libraryName ];
        yourself

    "Created: / 09-08-2006 / 11:17:59 / fm"
    "Modified: / 16-08-2006 / 18:19:25 / User"
!

classLine_libInit_dot_cc_mappings: aClassName

^Dictionary new                                               
    at: #'CLASS' put: [self st2c:aClassName];
    yourself

    "Created: / 08-08-2006 / 14:04:00 / fm"
    "Modified: / 09-08-2006 / 18:27:07 / fm"
!

extensionLine_libInit_dot_cc_mappings

^Dictionary new                                               
    at: #'LIBRARY_NAME' put: [self libraryName];
    yourself

    "Created: / 09-08-2006 / 11:19:59 / fm"
!

libInit_dot_cc_mappings

^Dictionary new
    at: #'LIBRARY_NAME' put: [self libraryName];
    at: #'PACKAGE' put: [self package];
    at: #'CLASSES' put: [self generateClassLines_libInit_dot_cc];
    at: #'EXTENSION' put: [self generateExtensionLine_libInit_dot_cc];

    yourself

    "Created: / 09-08-2006 / 11:20:24 / fm"
    "Modified: / 16-08-2006 / 18:19:03 / User"
!

make_dot_proto_mappings

^Dictionary new
    at: #'TOP' put: [self unixPathToTop];
    at: #'SUBDIRECTORIES' put: [self generateSubDirectories];
    at: #'LOCAL_INCLUDES' put: [self generateUnixLocalIncludes];
    at: #'LOCAL_DEFINES' put: [''];
    yourself

    "Created: / 09-08-2006 / 11:20:45 / fm"
    "Modified: / 09-08-2006 / 16:44:48 / fm"
!

make_dot_spec_mappings

^Dictionary new
    at: #'MODULE' put: [self module];  
    at: #'MODULE_DIRECTORY' put: [self moduleDirectory];  
    at: #'LIBRARY_NAME' put: [self libraryName];
    at: #'OBJECTS' put: [self generateObjects_make_dot_spec];  
    yourself

    "Created: / 09-08-2006 / 11:21:06 / fm"
!

nt_dot_def_mappings

^Dictionary new
    at: #'LIBRARY_NAME' put: [self libraryName];
    at: #'DESCRIPTION' put: [self description storeString];
    at: #'VERSION_NUMBER' put: [self versionNumber];
    yourself

    "Created: / 09-08-2006 / 11:21:21 / fm"
!

nt_dot_mak_mappings

^Dictionary new
    at: #'TOP' put: [self msdosPathToTop]; 
    at: #'LOCAL_INCLUDES' put: [self generateMsdosLocalIncludes];
    yourself

    "Created: / 09-08-2006 / 11:44:36 / fm"
    "Modified: / 09-08-2006 / 20:00:01 / fm"
!

objectLine_make_dot_spec_mappings: aClassName

^Dictionary new                                               
    at: #'CLASS' put: [(Smalltalk classNamed:aClassName) classFilename asFilename withoutSuffix baseName];
    yourself

    "Created: / 08-08-2006 / 20:17:28 / fm"
    "Modified: / 09-08-2006 / 18:26:52 / fm"
!

st2c:aString
        ^ (aString asString
            copyReplaceString:'_' withString:('_',($_ codePoint printStringRadix:8)))
                replaceAny:':' with:$_
! !

!ProjectDefinition class methodsFor:'mappings support'!

generateClassLines_libInit_dot_cc

^self compiled_classNames 
    inject: ''
    into:[:classLines :className | 
        |newClassLine mappings|

        mappings := self classLine_libInit_dot_cc_mappings: className.
        newClassLine := self replaceMappings: mappings  
                            in: self classLine_libInit_dot_cc.
        classLines concatenate: newClassLine 
                    and: String lf
    ]

"
    bosch_dapasx_datenbasis  generateClassLines_libInit_dot_cc
    bosch_dapasx_kernel  generateClassLines_libInit_dot_cc

"

    "Created: / 09-08-2006 / 11:21:48 / fm"
    "Modified: / 16-08-2006 / 18:52:10 / User"
!

generateExtensionLine_libInit_dot_cc
      |mappings|
^self extensionMethodNames isEmpty
    ifTrue:['']
    ifFalse:[ mappings := self extensionLine_libInit_dot_cc_mappings.
              self replaceMappings: mappings  
                            in: self extensionLine_libInit_dot_cc.]
"
    DapasXProject generateExtensionLine_libInit_dot_cc
    DapasX_Datenbasis generateExtensionLine_libInit_dot_cc

"

    "Created: / 09-08-2006 / 11:23:34 / fm"
!

generateMsdosLocalIncludes

^self searchForProjectsWhichProvideHeaderFiles
    inject: ''
    into:[:objectLines :includeProjectName |    
            objectLines , ' -I',(self msdosPathToPackage: includeProjectName) 
    ]

"
    DapasXProject generateLocalIncludes
    DapasX_Datenbasis generateLocalIncludes

"

    "Created: / 09-08-2006 / 16:46:49 / fm"
!

generateObjects_make_dot_spec 
    |pivateClassesOf classes|

    classes := self compiled_classes.
    pivateClassesOf := IdentityDictionary new.
    classes do:[:each | pivateClassesOf at:each put:(each allPrivateClasses)].

    classes topologicalSort:[:a :b |
        "/ a must come before b iff:
        "/    b is a subclass of a
        "/    b has a private class which is a subclass of a

        |mustComeBefore pivateClassesOfB|

        mustComeBefore := false.                        
        (a isSharedPool and:[(b sharedPools includes: a name)]) ifTrue:[
            mustComeBefore := true
        ].

        mustComeBefore := mustComeBefore or:[b isSubclassOf:a].
        pivateClassesOfB := pivateClassesOf at:b.
        pivateClassesOfB do:[:eachClassInB |
            mustComeBefore := mustComeBefore or:[eachClassInB isSubclassOf:a]
        ].
        mustComeBefore
    ].

    ^ String streamContents:[:s |
        classes do:[:eachClass |
            |mappings newObjectLine|

            mappings := self objectLine_make_dot_spec_mappings: eachClass name.
            newObjectLine := self replaceMappings: mappings in: self objectLine_make_dot_spec.
            s nextPutLine:newObjectLine. 
        ].
        self extensionMethodNames notEmpty
            ifTrue:[
                s nextPutLine:'    extensions.$(O) \'. 
            ]
    ]
"
    bosch_dapasx_hw_schnittstellen_Definition generateObjects_make_dot_spec
    DapasXProject generateObjects_make_dot_spec
    DapasX_Datenbasis generateObjects_make_dot_spec

"

    "Created: / 09-08-2006 / 11:24:39 / fm"
!

generatePrerequisiteProjectsPaths

^self prerequisiteProjects
    inject: ''
    into:[:objectLines :subProjectName |    
        objectLines
            concatenate: String lf
            and: ' -I'
            and: subProjectName 
    ]

"
    DapasXProject generatePrerequisiteProjectsPaths
    DapasX_Datenbasis generatePrerequisiteProjectsPaths

"

    "Created: / 09-08-2006 / 12:34:20 / fm"
!

generateSubDirectories

^self subProjects 
    inject: ''
    into:[:objectLines :subProjectName |    
        objectLines
            concatenate: ' '
            and: subProjectName 
    ]

"
    DapasXProject generateSubDirectories
    DapasX_Datenbasis generateSubDirectories

"

    "Created: / 09-08-2006 / 11:26:59 / fm"
!

generateUnixLocalIncludes

^self searchForProjectsWhichProvideHeaderFiles
    inject: ''
    into:[:objectLines :includeProjectName |    
            objectLines , ' -I',(self unixPathToPackage: includeProjectName) 
    ]

"
    DapasXProject generateLocalIncludes
    DapasX_Datenbasis generateLocalIncludes

"

    "Created: / 09-08-2006 / 16:46:49 / fm"
!

prerequisiteProjectsOrdered

^self prerequisiteProjects asSortedCollection:[:a :b | ]

"
    DapasXProject generatePrerequisiteProjectsPaths
    DapasX_Datenbasis generatePrerequisiteProjectsPaths

"

    "Created: / 09-08-2006 / 13:12:01 / fm"
! !

!ProjectDefinition class methodsFor:'sanity checks'!

searchForInconsistencies
    self searchForNeverCompiledSuperclasses.

"
    self searchForInconsistencies
    DapasX_Datenbasis searchForInconsistencies  
"

    "Created: / 09-08-2006 / 16:30:46 / fm"
!

searchForNeverCompiledSuperclasses
      self compiled_classesDo:[:includedClass | 
            includedClass allSuperclassesDo:[:eachSuperClass |
                eachSuperClass package == Project noProjectID ifTrue:[ 
                    self inconsistency:'uncompiled superclass: ' , eachSuperClass name
                ].
            ]
      ].

"
    self searchForNeverCompiledSuperclasses
    DapasX_Datenbasis searchForNeverCompiledSuperclasses  
"

    "Created: / 09-08-2006 / 16:31:54 / fm"
! !

!ProjectDefinition class methodsFor:'testing'!

isProjectDefinition
    ^ self ~~ ProjectDefinition

    "Created: / 17-08-2006 / 14:11:46 / cg"
! !

!ProjectDefinition class methodsFor:'update description'!

autoloadedClassNamesGeneratedCodeToCompile
    |classNamesCode|

   classNamesCode := 'autoloaded_classNames', String lf, '"This method has been automatically generated"'.
   classNamesCode := classNamesCode, String lf, self autoloadedClassNamesGeneratedString. 
   ^classNamesCode

"
    DapasXProject autoloadedClassNamesGeneratedCodeToCompile
    DapasX_Datenbasis autoloadedClassNamesGeneratedCodeToCompile

"

    "Created: / 08-08-2006 / 15:07:06 / fm"
!

autoloadedClassNamesGeneratedString
    | |

    ^ String streamContents:[:s |
        s nextPutAll:'^#('.
        self searchForClassesWithProject do:[:eachClass |
            (false "eachClass wasAutoloaded" or:[ eachClass isLoaded not ]) ifTrue:[
                (self compiled_classNames includes:eachClass name) ifFalse:[
                    (self excluded_classNames includes:eachClass name) ifFalse:[
                        s cr; nextPutAll:eachClass name asString storeString
                    ]
                ]
             ]
        ].
        s cr; nextPutAll:')'
    ].

"
    bosch_dapasx_interactiver_editor autoloadedClassNamesGeneratedString
"

    "Created: / 08-08-2006 / 15:00:17 / fm"
    "Modified: / 08-08-2006 / 19:24:34 / fm"
    "Modified: / 11-08-2006 / 14:01:23 / cg"
!

classNamesGeneratedCodeToCompile
    |classNamesCode|

   classNamesCode := 'compiled_classNames', String lf, '"This method has been automatically generated"'.
   classNamesCode := classNamesCode, String lf, self classNamesGeneratedString. 
   ^classNamesCode

"
    DapasXProject Datenbasis
    DapasX_Datenbasis Datenbasis

"

    "Created: / 08-08-2006 / 15:07:06 / fm"
!

classNamesGeneratedString
    | |

    ^ String streamContents:[:s |
        s nextPutAll:'^#('.
        self searchForClassesWithProject do:[:eachClass |
            (self autoloaded_classNames includes:eachClass name) ifFalse:[ 
                (self excluded_classNames includes:eachClass name) ifFalse:[ 
                    s cr; nextPutAll:eachClass name asString storeString
                 ]
             ]
        ].
        s cr; nextPutAll:')'
    ].

"
    bosch_dapasx_interactiver_editor classNamesGeneratedString
"

    "Created: / 08-08-2006 / 15:00:17 / fm"
    "Modified: / 08-08-2006 / 19:24:34 / fm"
    "Modified: / 11-08-2006 / 14:01:26 / cg"
!

extensionMethodNamesGeneratedCodeToCompile
    |extensionMethodNamesCode|

   extensionMethodNamesCode := 'extensionMethodNames', String lf, '"This method has been automatically generated"'.
   extensionMethodNamesCode := extensionMethodNamesCode, String lf, self extensionMethodNamesGeneratedString. 
   ^extensionMethodNamesCode

"
    DapasXProject extensionMethodNamesGeneratedCodeToCompile
    DapasX_Datenbasis extensionMethodNamesGeneratedCodeToCompile

"

    "Created: / 08-08-2006 / 18:54:42 / fm"
!

extensionMethodNamesGeneratedString
    |generatedString |

    generatedString := self searchForExtensionsWithProject 
            inject: '^#(' 
            into:[:string :each | 
                string, String lf, each mclass name asString storeString, ' #', each name ]. 
    ^generatedString, String lf, ')'

"
    self extensionMethodNamesGeneratedString
"

    "Created: / 08-08-2006 / 18:55:04 / fm"
!

forEachMethodsCodeToCompileDo:aTwoArgBlock
    aTwoArgBlock 
        value:self autoloadedClassNamesGeneratedCodeToCompile
        value:'description'.

   aTwoArgBlock
        value: self classNamesGeneratedCodeToCompile
        value: 'description'.

   (self theMetaclass includesSelector:#excluded_classNames) ifFalse:[
       aTwoArgBlock
            value: 'excluded_classNames\^ #()' withCRs
            value: 'description'.
   ].

   aTwoArgBlock 
        value: self extensionMethodNamesGeneratedCodeToCompile
        value: 'description'.

"/   aTwoArgBlock 
"/        value: 'description ^''bla bla'''
"/        value: 'description'

    "Created: / 10-08-2006 / 16:35:47 / cg"
! !

!ProjectDefinition class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic/LibraryDefinition.st,v 1.21 2006-08-17 14:11:00 cg Exp $'
! !
